/***************************************/
/*			Oil Panic V 1.0			   */
/*	(c) Oct. 2001 Martin Bergmann	   */
/* http://stud3.tuwien.ac.at/~e9527180 */
/* e9527180@stud3.tuwien.ac.at		   */
/* ----------------------------------- */
/* This souce is free, open and		   */
/* whatever. Use it on your own risk   */
/* Only for non-commerical purposes	   */
/***************************************/

class Timer extends Thread 
{
	OilPanic main;
	public Timer(OilPanic op)
	{
		main=op;
	}
	public void run() 
	{
		while (true) 
		{
			try
			{
				if (!main.isPaused()&&(!main.isGameOver())&&(!main.isTitel()))
				{
					for (int y=8;y>0 ;y--) for (int x=0;x<8 ;x++) main.area[x][y]=main.area[x][y-1]; // drops 1 row down
					for (int x=0;x<8 ;x++) main.area[x][0]=0;			// upper row no drops
					if((Math.random()*10)>4) main.area[(int)(Math.random()*8)][0]=1;	// add drop on random place (1st row)
					// Check last line
					for (int x=0;x<8 ;x++) 
					{
						if ((main.area[x][8]==1)&&(main.getXPos()==x)) // Got the oil
						{
							main.area[x][8]=0;
							main.incSaved();
						}
						else if (main.area[x][8]==1) main.incMissed(); // missed it
					}
					main.repaint();
					sleep(main.getTime());	
				}
				else 
				{
					sleep(100);								// While paused give other tasks a chance
					main.repaint();
				}
			} 
			catch ( Exception e ) 
			{
				System.out.println ("Timer:"+e);
			}
		}
	}
}